//cl /LD Main.c Registry.c kernel32.lib user32.lib gdi32.lib UUID.lib Advapi32.lib Ole32.lib oleaut32.lib CERes.obj CE.def /FeCD.dll
#include      <windows.h>         //RegSvr32 C:\Code\VStudio\VC++6\Projects\COM\CE\CE\Release\CE.dll
#include      <ocidl.h>
#include      <string.h>   
#include      <stdio.h> 
#include      "Registry.h"      
const         CLSID CLSID_CE      ={0x20000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x50}}; 
const         IID   IID_ICE       ={0x20000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x51}};
const         IID   IID_IOutGoing ={0x20000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x52}};
const         IID   LIBID_CE      ={0x20000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x53}};
HINSTANCE     g_hModule           =NULL;              //Store dll instance handle
const char    g_szFriendlyName[]  ="Com Control CE";  //Store friendly name of component
const char    g_szVerIndProgID[]  ="ComCtrl.CE";      //Store Version Independent ProgID
const char    g_szProgID[]        ="ComCtrl.CE.1";    //Store Versioned Program ID.
long          g_lObjs             =0;
long          g_lLocks            =0;
long          g_CtrlId            =1500;
IClassFactory CEClassFactory; 


//CE
typedef struct IComCtrlVtbl IComCtrlVtbl;  

typedef interface IComCtrl                   
{                             
 const IComCtrlVtbl* lpVtbl;         
}IComCtrl;                           

struct IComCtrlVtbl
{
 HRESULT (__stdcall* QueryInterface) (IComCtrl*, const IID*, void**);  
 ULONG   (__stdcall* AddRef)         (IComCtrl*                    );  
 ULONG   (__stdcall* Release)        (IComCtrl*                    ); 
 HRESULT (__stdcall* Initialize)     (IComCtrl*                    );
 HRESULT (__stdcall* CreateControl)  (IComCtrl*, const int         );
 HRESULT (__stdcall* SetColor)       (IComCtrl*, int               );
 HRESULT (__stdcall* GetColor)       (IComCtrl*, int*              );
 HRESULT (__stdcall* GetCtrlId)      (IComCtrl*, int*              );
 HRESULT (__stdcall* GetHWND)        (IComCtrl*, int*              );
};

typedef struct      
{                  
 IComCtrlVtbl*                    lpIComCtrlVtbl;    
 IConnectionPointContainerVtbl*   lpICPCVtbl;       
 IConnectionPointVtbl*            lpICPVtbl;
 HWND                             hContainer;
 HWND                             hControl;
 int                              m_cRef;   
}CE; 


//IOutGoing
typedef struct IOutGoingVtbl IOutGoingVtbl;

typedef interface IOutGoing
{
 const IOutGoingVtbl* lpVtbl;
}IOutGoing;

struct IOutGoingVtbl
{
 HRESULT (__stdcall* QueryInterface )(IOutGoing* this, REFIID riid, void** ppvObject);
 ULONG   (__stdcall* AddRef         )(IOutGoing* this                               );
 ULONG   (__stdcall* Release        )(IOutGoing* this                               );
 HRESULT (__stdcall* ControlEvent   )(IOutGoing* this, int Message                  );
};

IOutGoing*  g_pOutGoing    = 0;


HRESULT __stdcall IComCtrl_QueryInterface(IComCtrl* this, const IID* iid, void** ppv)
{                                     
 *ppv=0;                                
 if(!memcmp(iid,&IID_IUnknown,16))        
 {                                      
    printf("  QueryInterface(IID_IUnknown)\t");    
    printf("this = %u\n",this);
    this->lpVtbl->AddRef(this);        
    *ppv=this; 
    return S_OK;     
 }                                     
 if(!memcmp(iid, &IID_ICE, 16))         
 {                                     
    printf("  QueryInterface(IID_ICD)\t");    
    printf("this = %u\n",this);           
    this->lpVtbl->AddRef(this);        
    *ppv=this; 
    return S_OK;                              
 }
 if(!memcmp(iid,&IID_IConnectionPointContainer,16))
 {
    IConnectionPointContainer* pCPC=(IConnectionPointContainer*)this;
    printf("  QueryInterface(IID_IConnectionPointContainer)\t");  
    printf("  this = %u\n",this);
    pCPC++;
    printf("  pCPC = %u\n",pCPC);
    *ppv=pCPC;
    pCPC->lpVtbl->AddRef(pCPC);
    return S_OK;
 }                                     
 if(!memcmp(iid,&IID_IConnectionPoint,16))
 {
    IConnectionPoint* pCP=(IConnectionPoint*)this;
    pCP++, pCP++;
    *ppv=pCP;
    pCP->lpVtbl->AddRef(pCP);
    return S_OK;
 }                                        
 printf("Called ICD_QueryInterface()"); 
 printf("\tthis=%u\n",this);           
                                       
 return(E_NOINTERFACE);                 
}                                      
                                  

ULONG __stdcall IComCtrl_AddRef(IComCtrl* this)    
{                                      
 printf("  Called ICD_AddRef()!\t\t");    
 printf("this=%u\n",this);                
 return(++((CE*)this)->m_cRef);        
}                                       


ULONG __stdcall IComCtrl_Release(IComCtrl* this)   
{                                      
 if(--((CE*)this)->m_cRef == 0)        
 {                                      
     CoTaskMemFree(this);              
     InterlockedDecrement(&g_lObjs);   
     printf("Called ICE_Release() ");   
     printf("And CE Was Deleted!\n"); 
     SendMessage(((CE*)this)->hControl,WM_CLOSE,0,0); 
     return(0);                        
 }                                     
 printf("  Called ICE_Release()!\t\t");
 printf("this=%u\n",this);

 return(((CE*)this)->m_cRef);
}


long __stdcall fnWndProc(HWND hwnd, unsigned int msg, WPARAM wParam,LPARAM lParam)
{
 switch(msg)
 {
   case WM_CREATE:
     printf("  ComCtrl Received WM_CREATE Message!\n");
     SetWindowLong(hwnd,0,(long)RGB(255,255,0));
     if(g_pOutGoing)
        g_pOutGoing->lpVtbl->ControlEvent(g_pOutGoing,(int)WM_CREATE);
     return 0;
   case WM_LBUTTONDOWN:
     printf("ComCtrl Received WM_LBUTTONDOWN Message!\n");
     if(g_pOutGoing)
        g_pOutGoing->lpVtbl->ControlEvent(g_pOutGoing,(int)WM_LBUTTONDOWN);
     SetFocus(hwnd);
     return 0;
   case WM_CHAR:
     printf("ComCtrl Received WM_CHAR Message!\n");
     if(g_pOutGoing)
        g_pOutGoing->lpVtbl->ControlEvent(g_pOutGoing,(int)WM_CHAR);
     return 0;
   case WM_PAINT:
     {
        HDC hDC;
        PAINTSTRUCT ps;
        HBRUSH hNewBrush;
        hDC=BeginPaint(hwnd,&ps);
        hNewBrush=CreateSolidBrush((COLORREF)GetWindowLong(hwnd,0));
        FillRect(hDC,&ps.rcPaint,hNewBrush);
        DrawText(hDC, "Click Me!",-1,&ps.rcPaint,DT_SINGLELINE|DT_CENTER|DT_VCENTER);
        DeleteObject(hNewBrush);
        EndPaint(hwnd,&ps); 
        return 0;           
     }
   case WM_CLOSE:
     printf("ComCtrl Received WM_CLOSE Message!\n");
     if(g_pOutGoing)
        g_pOutGoing->lpVtbl->ControlEvent(g_pOutGoing,(int)WM_CLOSE);
     DestroyWindow(hwnd);
     return 0;
 }
   
 return (DefWindowProc(hwnd, msg, wParam, lParam));
}


HRESULT __stdcall Initialize(IComCtrl* this)
{
 char szClassName[]="ComCtrl";
 WNDCLASSEX wc;

 printf("  Called Initialize()\n");
 wc.lpszClassName=szClassName;                            wc.lpfnWndProc=fnWndProc;
 wc.cbSize=sizeof (WNDCLASSEX);                           wc.style=CS_GLOBALCLASS;
 wc.hIcon=LoadIcon(NULL,IDI_APPLICATION);                 wc.hInstance=g_hModule;
 wc.hIconSm=LoadIcon(NULL, IDI_APPLICATION);              wc.hCursor=LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);    wc.cbWndExtra=4;
 wc.lpszMenuName=NULL; 
 wc.cbClsExtra=0;
 if(RegisterClassEx(&wc))
    return S_OK;

 return S_FALSE;
}


HRESULT __stdcall CreateControl(IComCtrl* this, const int hContainer)
{
 HWND hCtl;
 RECT rc;

 printf("  Called CreateControl()  -  hContainer = %u\n",hContainer);
 GetClientRect((HWND)hContainer,&rc);
 printf("  rc.right  = %u\n",rc.right);
 printf("  rc.bottom = %u\n",rc.bottom);
 hCtl=CreateWindow("ComCtrl","",WS_CHILD|WS_VISIBLE,0,0,rc.right,rc.bottom,(HWND)hContainer,(HMENU)g_CtrlId,g_hModule,0);
 g_CtrlId++;
 ((CE*)this)->hControl=hCtl;
 ((CE*)this)->hContainer=(HWND)hContainer;
 ShowWindow(hCtl,SW_SHOWNORMAL);
 SetFocus(hCtl); 

 return S_OK;
}


HRESULT __stdcall SetColor(IComCtrl* this, int iColor)
{
 CE* pCE;

 pCE=(CE*)this;
 SetWindowLong(pCE->hControl,0,(long)iColor);
 InvalidateRect(pCE->hControl,0,TRUE);

 return S_OK;
}


HRESULT __stdcall GetColor(IComCtrl* this, int* ptrColor)
{
 CE* pCE=(CE*)this;
 *ptrColor=(int)GetWindowLong(pCE->hControl,0); 
 return S_OK;
}


HRESULT __stdcall GetCtrlId(IComCtrl* this, int* ptrCtrlId)
{
 CE* pCE=(CE*)this;
 *ptrCtrlId=(int)GetDlgCtrlID(pCE->hControl);
 return S_OK;
}


HRESULT __stdcall GetHWND(IComCtrl* this, int* ptrWindowHandle)
{
 CE* pCE=(CE*)this;
 *ptrWindowHandle=(int)pCE->hControl;
 return S_OK;
}


const IComCtrlVtbl IComCtrl_Vtbl=
{
 IComCtrl_QueryInterface,
 IComCtrl_AddRef,
 IComCtrl_Release,
 Initialize,
 CreateControl,
 SetColor,
 GetColor,
 GetCtrlId,
 GetHWND
};  


HRESULT __stdcall CEConnectionPointContainer_QueryInterface(IConnectionPointContainer* this, REFIID iid, void** ppvObject)
{
 printf("  Entering CEConnectionPointContainer_QueryInterface() -- this = %u\n",this);
 *ppvObject=0;
 if(!memcmp(iid,&IID_IUnknown,16))                           
 {
    IComCtrl* pCtrl=(IComCtrl*)this;
    printf("  Somebody's Looking For IID_IUnknown!\n");
    pCtrl--;
    *ppvObject=pCtrl;
    pCtrl->lpVtbl->AddRef(pCtrl);
    return S_OK;
 }
 if(!memcmp(iid,&IID_ICE,16))                           
 {
    IComCtrl* pCtrl=(IComCtrl*)this;
    printf("  Somebody's Looking For IID_ICD!\n");
    pCtrl--;
    *ppvObject=pCtrl;
    pCtrl->lpVtbl->AddRef(pCtrl);
    return S_OK;
 }
 if(!memcmp(iid,&IID_IConnectionPointContainer,16))
 {
    printf("  Somebody's Looking For IID_IConnectionPointContainer!\n");
    this->lpVtbl->AddRef(this);
    *ppvObject=this;
    return S_OK;
 }
 if(!memcmp(iid,&IID_IConnectionPoint,16))                           
 {
    IConnectionPoint* pCP=(IConnectionPoint*)this;
    printf("  In CDConnectionPointContainer_QueryInterface()\n");
    printf("  Somebody's Looking For IID_IConnectionPoint!\n");
    pCP++;
    printf("  pCP = %u\n",pCP);
    *ppvObject=pCP;
    pCP->lpVtbl->AddRef(pCP);
    return S_OK;
 }
 
 return(E_NOINTERFACE); 
} 
 

ULONG __stdcall CEConnectionPointContainer_AddRef(IConnectionPointContainer* this)  
{                                                           
 this--;
 return(++((CE*)this)->m_cRef);
}


ULONG __stdcall CEConnectionPointContainer_Release(IConnectionPointContainer* this)
{
 CE* pCE;

 this--;
 pCE=(CE*)this;
 pCE->m_cRef--;
 if(!pCE->m_cRef)
 {
    CoTaskMemFree(this);
    InterlockedDecrement(&g_lObjs);
    return 0;
 }

 return pCE->m_cRef;
}


HRESULT __stdcall CEConnectionPointContainer_EnumConnectionPoints(IConnectionPointContainer* this, IEnumConnectionPoints** ppEnum)
{
 return E_NOTIMPL;
}


HRESULT __stdcall CEConnectionPointContainer_FindConnectionPoint(IConnectionPointContainer* this, REFIID iid, IConnectionPoint** ppCP)
{
 HRESULT hr;

 if(!memcmp(iid,&IID_IOutGoing,16))
 {
    printf("  Entering CDConnectionPointContainer_FindConnectionPoint(IID_IOutGoing)\n");
    printf("    this  = %u\n",this);
    printf("    *ppCP = %u\n",*ppCP);
    hr=this->lpVtbl->QueryInterface(this,&IID_IConnectionPoint,ppCP); 
    printf("    this->lpVtbl->QueryInterface(IID_IConnectionPoint) Succeeded!\n"); 
    printf("    *ppCP = %u\n",*ppCP);
    printf("  Leaving FindConnectionPoint()\n");
    return hr;   
 }

 return E_NOINTERFACE;  
}


const IConnectionPointContainerVtbl IConnectionPointContainer_Vtbl=                 
{                                                           
 CEConnectionPointContainer_QueryInterface,                            
 CEConnectionPointContainer_AddRef,                                    
 CEConnectionPointContainer_Release,                                   
 CEConnectionPointContainer_EnumConnectionPoints,                            
 CEConnectionPointContainer_FindConnectionPoint
};


HRESULT __stdcall CEConnectionPoint_QueryInterface(IConnectionPoint* this, REFIID iid, void** ppvObject)
{
 *ppvObject=0;
 if(!memcmp(iid,&IID_IUnknown,16))                           
 {
    IComCtrl* pCtrl=(IComCtrl*)this;
    pCtrl--, pCtrl--;
    *ppvObject=pCtrl;
    pCtrl->lpVtbl->AddRef(pCtrl);
    return S_OK;
 }
 if(!memcmp(iid,&IID_ICE,16))                           
 {
    IComCtrl* pCtrl=(IComCtrl*)this;
    pCtrl--, pCtrl--;
    *ppvObject=pCtrl;
    pCtrl->lpVtbl->AddRef(pCtrl);
    return S_OK;
 }
 if(!memcmp(iid,&IID_IConnectionPointContainer,16))
 {
    IConnectionPointContainer* pCPC=(IConnectionPointContainer*)this;
    pCPC--;
    *ppvObject=pCPC;
    pCPC->lpVtbl->AddRef(pCPC);
    return S_OK;  
 }
 if(!memcmp(iid,&IID_IConnectionPoint,16))
 {
    this->lpVtbl->AddRef(this);
    *ppvObject=this;
    return S_OK;
 }
  
 return(E_NOINTERFACE); 
}


HRESULT __stdcall CEConnectionPoint_AddRef(IConnectionPoint* this)
{
 this--, this--;
 return(++((CE*)this)->m_cRef);
}


HRESULT __stdcall CEConnectionPoint_Release(IConnectionPoint* this)
{
 CE* pCE;

 this--, this--;
 pCE=(CE*)this;
 pCE->m_cRef--;
 if(!pCE->m_cRef)
 {
    CoTaskMemFree(this);
    InterlockedDecrement(&g_lObjs);
    return 0;
 }

 return pCE->m_cRef;
}


HRESULT __stdcall CEConnectionPoint_GetConnectionInterface(IConnectionPoint* this, IID* pIID)
{
 return E_NOTIMPL;
}


HRESULT __stdcall CEConnectionPoint_GetConnectionPointContainer(IConnectionPoint* this, IConnectionPointContainer** ppCPC)
{
 return E_NOTIMPL;
}


HRESULT __stdcall CEConnectionPoint_Advise(IConnectionPoint* this, IUnknown* pUnkSink, DWORD* pdwCookie)
{
 HRESULT hr;                                                      
                                                                  
 printf("\nEntering IConnectionPoint::Advise\n");                 
 printf("  pUnkSink     = %u\n",pUnkSink);                        
 printf("  g_pOutGoing  = %u\n",g_pOutGoing);                        
 *pdwCookie=1;                                                       
 hr=pUnkSink->lpVtbl->QueryInterface(pUnkSink, &IID_IOutGoing, (void**)&g_pOutGoing); 
 printf("  &g_pOutGoing = %u\n",&g_pOutGoing);
 printf("  g_pOutGoing  = %u\n",g_pOutGoing);
 printf("Leaving IConnectionPoint::Advise()\n\n");

 return hr;
}


HRESULT __stdcall CEConnectionPoint_Unadvise(IConnectionPoint* this, DWORD dwCookie)
{
 printf("Unadvise\n");
 g_pOutGoing->lpVtbl->Release(g_pOutGoing);
 g_pOutGoing=0;

 return NOERROR;

}



HRESULT __stdcall CEConnectionPoint_EnumConnections(IConnectionPoint* this, IEnumConnections** ppEnum)
{
 return E_NOTIMPL;
}


const IConnectionPointVtbl IConnectionPoint_Vtbl=                 
{                                                           
 CEConnectionPoint_QueryInterface,                            
 CEConnectionPoint_AddRef,                                    
 CEConnectionPoint_Release,                                   
 CEConnectionPoint_GetConnectionInterface,                            
 CEConnectionPoint_GetConnectionPointContainer,
 CEConnectionPoint_Advise,
 CEConnectionPoint_Unadvise,
 CEConnectionPoint_EnumConnections
};

 

HRESULT __stdcall CEClassFactory_QueryInterface(IClassFactory* this, REFIID riid, void** ppv)
{
 if(IsEqualIID(riid,&IID_IUnknown) || IsEqualIID(riid,&IID_IClassFactory))
 {
    this->lpVtbl->AddRef(this); 
    *ppv=this;                  
    return(NOERROR);            
 }                               
 *ppv=0;                        
                                
 return(E_NOINTERFACE);         
}


ULONG __stdcall CEClassFactory_AddRef(IClassFactory* this)  
{                                                           
 InterlockedIncrement(&g_lObjs);                            
 return(1);
}


ULONG __stdcall CEClassFactory_Release(IClassFactory* this)
{
 return(InterlockedDecrement(&g_lObjs));
}


HRESULT __stdcall CEClassFactory_CreateInstance(IClassFactory* this, IUnknown* pUnkOuter, REFIID iid, void** ppv)
{
 CE* pCE=NULL;                                              
 HRESULT hr;                                              
	
 printf("  Entering CEClassFactory_CreateInstance()\n");                                                             
 *ppv=0;                                                   
 if(pUnkOuter)                                              
    hr=CLASS_E_NOAGGREGATION;                              
 else                                                      
 {                                                         
    pCE=(CE*)CoTaskMemAlloc(sizeof(CE));
    printf("    pCE                 = %u\n",pCE);                    
    if(pCE)                                                 
    {    
       pCE->lpIComCtrlVtbl=(IComCtrlVtbl*)&IComCtrl_Vtbl; 
       pCE->lpICPCVtbl=(IConnectionPointContainerVtbl*)&IConnectionPointContainer_Vtbl;
       pCE->lpICPVtbl=(IConnectionPointVtbl*)&IConnectionPoint_Vtbl;
       printf("    pCE->lpIComCtrlVtbl = %u\n",pCE->lpIComCtrlVtbl);
       printf("    pCE->lpICPCVtbl     = %u\n",pCE->lpICPCVtbl);
       printf("    pCE->lpICPVtbl      = %u\n",pCE->lpICPVtbl);
       pCE->m_cRef=0; 
       pCE->hContainer=0;
       pCE->hControl=0;                               
       hr=pCE->lpIComCtrlVtbl->QueryInterface((IComCtrl*)pCE,iid,ppv); 
       if(SUCCEEDED(hr))                                    
          InterlockedIncrement(&g_lObjs);                  
       else                                                
          CoTaskMemFree(pCE);                              
    }                                                      
    else                                                   
       hr=E_OUTOFMEMORY;                                   
 } 
 printf("  Leaving CEClassFactory_CreateInstance()\n");                                                          
                                                           
 return(hr);                                               
} 


HRESULT __stdcall CEClassFactory_LockServer(IClassFactory* this, BOOL flock)
{
 if(flock)
    InterlockedIncrement(&g_lLocks);                        
 else                                                        
    InterlockedDecrement(&g_lLocks);                       
                                                           
 return(NOERROR);                                          
} 


const IClassFactoryVtbl IClassFactory_Vtbl=                 
{                                                           
 CEClassFactory_QueryInterface,                            
 CEClassFactory_AddRef,                                    
 CEClassFactory_Release,                                   
 CEClassFactory_CreateInstance,                            
 CEClassFactory_LockServer
};


HRESULT __stdcall DllGetClassObject(REFCLSID objGuid, REFIID facGuid, void** ppv)
{
 HRESULT hr;

 if(!memcmp(objGuid,&CLSID_CE,16))
    CEClassFactory_QueryInterface(&CEClassFactory, facGuid, ppv);
 else
 {
    *ppv=0;
    hr=CLASS_E_CLASSNOTAVAILABLE;
 }
 
 return(hr);
}


HRESULT __stdcall DllCanUnloadNow()
{
 if(g_lObjs||g_lLocks)
    return S_FALSE;
 else
    return S_OK;
}


STDAPI DllRegisterServer()
{
 ITypeLib* pTypeLib=NULL;
 HRESULT hr;
 FILE* fp;
 
 fp=fopen("C:\\Tallies\\Output.txt","w");
 fprintf(fp,"\nEntering RegisterComponent()\n");
 hr=LoadTypeLibEx(L"CE.dll", REGKIND_DEFAULT, &pTypeLib);
 if(SUCCEEDED(hr))
 {
    fprintf(fp,"LoadTypeLibEx() Succeeded!  Will Now Call RegisterServer()\n");
    hr=RegisterServer(g_hModule,&CLSID_CE,g_szFriendlyName,g_szVerIndProgID,g_szProgID);
    if(SUCCEEDED(hr))
       printf("RegisterServer() Succeeded!\n");
    else
       printf("RegisterServer() Failed!\n");
    fclose(fp);
    pTypeLib->lpVtbl->Release(pTypeLib);
    return hr;
 }
 else
 {
    fprintf(fp,"LoadTypeLibEx() Failed!\n");
    fclose(fp);
    return E_FAIL;
 }                       
}                         


STDAPI DllUnregisterServer()
{
 HRESULT hr;

 hr=UnRegisterTypeLib(&LIBID_CE,1,0,LANG_NEUTRAL,SYS_WIN32);  
 if(SUCCEEDED(hr))
    return UnregisterServer(&CLSID_CE,g_szVerIndProgID,g_szProgID);
 else
    return E_FAIL;
}  


BOOL __stdcall DllMain(HINSTANCE hInstance, DWORD fdwReason, LPVOID lpvReserved)
{
 if(fdwReason==DLL_PROCESS_ATTACH)
 {
    printf("  In DllMain - DLL_PROCESS_ATTACH\n");
    g_hModule=hInstance;
    CEClassFactory.lpVtbl = (IClassFactoryVtbl*)&IClassFactory_Vtbl;
    DisableThreadLibraryCalls(hInstance);
 }

 return(TRUE);
}
















/*
//cl /LD Main.c Registry.c kernel32.lib user32.lib gdi32.lib UUID.lib Advapi32.lib Ole32.lib oleaut32.lib CERes.obj CE.def /FeCD.dll
#include      <windows.h>         //RegSvr32 C:\Code\VStudio\VC++6\Projects\COM\CE\CE\Release\CE.dll
#include      <ocidl.h>
#include      <string.h>   
#include      <stdio.h> 
#include      "Registry.h"      
const         CLSID CLSID_CE      ={0x20000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40}}; 
const         IID   IID_ICE       ={0x20000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41}};
const         IID   IID_IOutGoing ={0x20000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x42}};
const         IID   LIBID_CE     = {0x20000000,0x0000,0x0000,{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x43}};
HINSTANCE     g_hModule           =NULL;              //Store dll instance handle
const char    g_szFriendlyName[]  ="Com Control CE";  //Store friendly name of component
const char    g_szVerIndProgID[]  ="ComCtrl.CE";      //Store Version Independent ProgID
const char    g_szProgID[]        ="ComCtrl.CE.1";    //Store Versioned Program ID.
long          g_lObjs             =0;
long          g_lLocks            =0;
long          g_CtrlId            =1500;
IClassFactory CEClassFactory; 


//CE
typedef struct IComCtrlVtbl IComCtrlVtbl;  

typedef interface IComCtrl                   
{                             
 const IComCtrlVtbl* lpVtbl;         
}IComCtrl;                           

struct IComCtrlVtbl
{
 HRESULT (__stdcall* QueryInterface) (IComCtrl*, const IID*, void**);  
 ULONG   (__stdcall* AddRef)         (IComCtrl*                    );  
 ULONG   (__stdcall* Release)        (IComCtrl*                    ); 
 HRESULT (__stdcall* Initialize)     (IComCtrl*                    );
 HRESULT (__stdcall* CreateControl)  (IComCtrl*, const int         );
 HRESULT (__stdcall* SetColor)       (IComCtrl*, int               );
 HRESULT (__stdcall* GetColor)       (IComCtrl*, int*              );
 HRESULT (__stdcall* GetCtrlId)      (IComCtrl*, int*              );
 HRESULT (__stdcall* GetHWND)        (IComCtrl*, int*              );
};

typedef struct      
{                  
 IComCtrlVtbl*                    lpIComCtrlVtbl;    
 IConnectionPointContainerVtbl*   lpICPCVtbl;       
 IConnectionPointVtbl*            lpICPVtbl;
 HWND                             hContainer;
 HWND                             hControl;
 int                              m_cRef;   
}CE; 


//IOutGoing
typedef struct IOutGoingVtbl IOutGoingVtbl;

typedef interface IOutGoing
{
 const IOutGoingVtbl* lpVtbl;
}IOutGoing;

struct IOutGoingVtbl
{
 HRESULT (__stdcall* QueryInterface )(IOutGoing* this, REFIID riid, void** ppvObject);
 ULONG   (__stdcall* AddRef         )(IOutGoing* this                               );
 ULONG   (__stdcall* Release        )(IOutGoing* this                               );
 HRESULT (__stdcall* ControlEvent   )(IOutGoing* this, int Message                  );
};

IOutGoing*  g_pOutGoing    = 0;


HRESULT __stdcall IComCtrl_QueryInterface(IComCtrl* this, const IID* iid, void** ppv)
{                                     
 *ppv=0;                                
 if(!memcmp(iid,&IID_IUnknown,16))        
 {                                      
    this->lpVtbl->AddRef(this);        
    *ppv=this; 
    return S_OK;     
 }                                     
 if(!memcmp(iid, &IID_ICE, 16))         
 {                                     
    this->lpVtbl->AddRef(this);        
    *ppv=this; 
    return S_OK;                              
 }
 if(!memcmp(iid,&IID_IConnectionPointContainer,16))
 {
    IConnectionPointContainer* pCPC=(IConnectionPointContainer*)this;
    pCPC++;
    *ppv=pCPC;
    pCPC->lpVtbl->AddRef(pCPC);
    return S_OK;
 }                                     
 if(!memcmp(iid,&IID_IConnectionPoint,16))
 {
    IConnectionPoint* pCP=(IConnectionPoint*)this;
    pCP++, pCP++;
    *ppv=pCP;
    pCP->lpVtbl->AddRef(pCP);
    return S_OK;
 }                                        
                                       
 return(E_NOINTERFACE);                 
}                                      
                                  

ULONG __stdcall IComCtrl_AddRef(IComCtrl* this)    
{                                      
 return(++((CE*)this)->m_cRef);        
}                                       


ULONG __stdcall IComCtrl_Release(IComCtrl* this)   
{                                      
 if(--((CE*)this)->m_cRef == 0)        
 {                                      
     CoTaskMemFree(this);              
     InterlockedDecrement(&g_lObjs);   
     SendMessage(((CE*)this)->hControl,WM_CLOSE,0,0); 
     return(0);                        
 }                                     
 
 return(((CE*)this)->m_cRef);
}


long __stdcall fnWndProc(HWND hwnd, unsigned int msg, WPARAM wParam,LPARAM lParam)
{
 switch(msg)
 {
   case WM_CREATE:
     SetWindowLong(hwnd,0,(long)RGB(255,255,0));
     if(g_pOutGoing)
        g_pOutGoing->lpVtbl->ControlEvent(g_pOutGoing,(int)WM_CREATE);
     return 0;
   case WM_LBUTTONDOWN:
     if(g_pOutGoing)
        g_pOutGoing->lpVtbl->ControlEvent(g_pOutGoing,(int)WM_LBUTTONDOWN);
     SetFocus(hwnd);
     return 0;
   case WM_CHAR:
     if(g_pOutGoing)
        g_pOutGoing->lpVtbl->ControlEvent(g_pOutGoing,(int)WM_CHAR);
     return 0;
   case WM_PAINT:
     {
        HDC hDC;
        PAINTSTRUCT ps;
        HBRUSH hNewBrush;
        hDC=BeginPaint(hwnd,&ps);
        hNewBrush=CreateSolidBrush((COLORREF)GetWindowLong(hwnd,0));
        FillRect(hDC,&ps.rcPaint,hNewBrush);
        DrawText(hDC, "Click Me!",-1,&ps.rcPaint,DT_SINGLELINE|DT_CENTER|DT_VCENTER);
        DeleteObject(hNewBrush);
        EndPaint(hwnd,&ps); 
        return 0;           
     }
   case WM_CLOSE:
     if(g_pOutGoing)
        g_pOutGoing->lpVtbl->ControlEvent(g_pOutGoing,(int)WM_CLOSE);
     DestroyWindow(hwnd);
     return 0;
 }
   
 return (DefWindowProc(hwnd, msg, wParam, lParam));
}


HRESULT __stdcall Initialize(IComCtrl* this)
{
 char szClassName[]="ComCtrl";
 WNDCLASSEX wc;

 wc.lpszClassName=szClassName;                            wc.lpfnWndProc=fnWndProc;
 wc.cbSize=sizeof (WNDCLASSEX);                           wc.style=CS_GLOBALCLASS;
 wc.hIcon=LoadIcon(NULL,IDI_APPLICATION);                 wc.hInstance=g_hModule;
 wc.hIconSm=LoadIcon(NULL, IDI_APPLICATION);              wc.hCursor=LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);    wc.cbWndExtra=4;
 wc.lpszMenuName=NULL; 
 wc.cbClsExtra=0;
 if(RegisterClassEx(&wc))
    return S_OK;

 return S_FALSE;
}


HRESULT __stdcall CreateControl(IComCtrl* this, const int hContainer)
{
 HWND hCtl;
 RECT rc;

 GetClientRect((HWND)hContainer,&rc);
 hCtl=CreateWindow("ComCtrl","",WS_CHILD|WS_VISIBLE,0,0,rc.right,rc.bottom,(HWND)hContainer,(HMENU)g_CtrlId,g_hModule,0);
 g_CtrlId++;
 ((CE*)this)->hControl=hCtl;
 ((CE*)this)->hContainer=(HWND)hContainer;
 ShowWindow(hCtl,SW_SHOWNORMAL);
 SetFocus(hCtl); 

 return S_OK;
}


HRESULT __stdcall SetColor(IComCtrl* this, int iColor)
{
 CE* pCE;

 pCE=(CE*)this;
 SetWindowLong(pCE->hControl,0,(long)iColor);
 InvalidateRect(pCE->hControl,0,TRUE);

 return S_OK;
}


HRESULT __stdcall GetColor(IComCtrl* this, int* ptrColor)
{
 CE* pCE=(CE*)this;
 *ptrColor=(int)GetWindowLong(pCE->hControl,0); 
 return S_OK;
}


HRESULT __stdcall GetCtrlId(IComCtrl* this, int* ptrCtrlId)
{
 CE* pCE=(CE*)this;
 *ptrCtrlId=(int)GetDlgCtrlID(pCE->hControl);
 return S_OK;
}


HRESULT __stdcall GetHWND(IComCtrl* this, int* ptrWindowHandle)
{
 CE* pCE=(CE*)this;
 *ptrWindowHandle=(int)pCE->hControl;
 return S_OK;
}


const IComCtrlVtbl IComCtrl_Vtbl=
{
 IComCtrl_QueryInterface,
 IComCtrl_AddRef,
 IComCtrl_Release,
 Initialize,
 CreateControl,
 SetColor,
 GetColor,
 GetCtrlId,
 GetHWND
};  


HRESULT __stdcall CEConnectionPointContainer_QueryInterface(IConnectionPointContainer* this, REFIID iid, void** ppvObject)
{
 *ppvObject=0;
 if(!memcmp(iid,&IID_IUnknown,16))                           
 {
    IComCtrl* pCtrl=(IComCtrl*)this;
    pCtrl--;
    *ppvObject=pCtrl;
    pCtrl->lpVtbl->AddRef(pCtrl);
    return S_OK;
 }
 if(!memcmp(iid,&IID_ICE,16))                           
 {
    IComCtrl* pCtrl=(IComCtrl*)this;
    pCtrl--;
    *ppvObject=pCtrl;
    pCtrl->lpVtbl->AddRef(pCtrl);
    return S_OK;
 }
 if(!memcmp(iid,&IID_IConnectionPointContainer,16))
 {
    this->lpVtbl->AddRef(this);
    *ppvObject=this;
    return S_OK;
 }
 if(!memcmp(iid,&IID_IConnectionPoint,16))                           
 {
    IConnectionPoint* pCP=(IConnectionPoint*)this;
    pCP++;
    *ppvObject=pCP;
    pCP->lpVtbl->AddRef(pCP);
    return S_OK;
 }
 
 return(E_NOINTERFACE); 
} 
 

ULONG __stdcall CEConnectionPointContainer_AddRef(IConnectionPointContainer* this)  
{                                                           
 this--;
 return(++((CE*)this)->m_cRef);
}


ULONG __stdcall CEConnectionPointContainer_Release(IConnectionPointContainer* this)
{
 CE* pCE;

 this--;
 pCE=(CE*)this;
 pCE->m_cRef--;
 if(!pCE->m_cRef)
 {
    CoTaskMemFree(this);
    InterlockedDecrement(&g_lObjs);
    return 0;
 }

 return pCE->m_cRef;
}


HRESULT __stdcall CEConnectionPointContainer_EnumConnectionPoints(IConnectionPointContainer* this, IEnumConnectionPoints** ppEnum)
{
 return E_NOTIMPL;
}


HRESULT __stdcall CEConnectionPointContainer_FindConnectionPoint(IConnectionPointContainer* this, REFIID iid, IConnectionPoint** ppCP)
{
 HRESULT hr;

 if(!memcmp(iid,&IID_IOutGoing,16))
 {
    hr=this->lpVtbl->QueryInterface(this,&IID_IConnectionPoint,ppCP); 
    return hr;   
 }

 return E_NOINTERFACE;  
}


const IConnectionPointContainerVtbl IConnectionPointContainer_Vtbl=                 
{                                                           
 CEConnectionPointContainer_QueryInterface,                            
 CEConnectionPointContainer_AddRef,                                    
 CEConnectionPointContainer_Release,                                   
 CEConnectionPointContainer_EnumConnectionPoints,                            
 CEConnectionPointContainer_FindConnectionPoint
};


HRESULT __stdcall CEConnectionPoint_QueryInterface(IConnectionPoint* this, REFIID iid, void** ppvObject)
{
 *ppvObject=0;
 if(!memcmp(iid,&IID_IUnknown,16))                           
 {
    IComCtrl* pCtrl=(IComCtrl*)this;
    pCtrl--, pCtrl--;
    *ppvObject=pCtrl;
    pCtrl->lpVtbl->AddRef(pCtrl);
    return S_OK;
 }
 if(!memcmp(iid,&IID_ICE,16))                           
 {
    IComCtrl* pCtrl=(IComCtrl*)this;
    pCtrl--, pCtrl--;
    *ppvObject=pCtrl;
    pCtrl->lpVtbl->AddRef(pCtrl);
    return S_OK;
 }
 if(!memcmp(iid,&IID_IConnectionPointContainer,16))
 {
    IConnectionPointContainer* pCPC=(IConnectionPointContainer*)this;
    pCPC--;
    *ppvObject=pCPC;
    pCPC->lpVtbl->AddRef(pCPC);
    return S_OK;  
 }
 if(!memcmp(iid,&IID_IConnectionPoint,16))
 {
    this->lpVtbl->AddRef(this);
    *ppvObject=this;
    return S_OK;
 }
  
 return(E_NOINTERFACE); 
}


HRESULT __stdcall CEConnectionPoint_AddRef(IConnectionPoint* this)
{
 this--, this--;
 return(++((CE*)this)->m_cRef);
}


HRESULT __stdcall CEConnectionPoint_Release(IConnectionPoint* this)
{
 CE* pCE;

 this--, this--;
 pCE=(CE*)this;
 pCE->m_cRef--;
 if(!pCE->m_cRef)
 {
    CoTaskMemFree(this);
    InterlockedDecrement(&g_lObjs);
    return 0;
 }

 return pCE->m_cRef;
}


HRESULT __stdcall CEConnectionPoint_GetConnectionInterface(IConnectionPoint* this, IID* pIID)
{
 return E_NOTIMPL;
}


HRESULT __stdcall CEConnectionPoint_GetConnectionPointContainer(IConnectionPoint* this, IConnectionPointContainer** ppCPC)
{
 return E_NOTIMPL;
}


HRESULT __stdcall CEConnectionPoint_Advise(IConnectionPoint* this, IUnknown* pUnkSink, DWORD* pdwCookie)
{
 HRESULT hr;                                                     
 
 *pdwCookie=1;                                                       
 hr=pUnkSink->lpVtbl->QueryInterface(pUnkSink, &IID_IOutGoing, (void**)&g_pOutGoing); 

 return hr;

}


HRESULT __stdcall CEConnectionPoint_Unadvise(IConnectionPoint* this, DWORD dwCookie)
{
 g_pOutGoing->lpVtbl->Release(g_pOutGoing);
 g_pOutGoing=0;

 return NOERROR;

}



HRESULT __stdcall CEConnectionPoint_EnumConnections(IConnectionPoint* this, IEnumConnections** ppEnum)
{
 return E_NOTIMPL;
}


const IConnectionPointVtbl IConnectionPoint_Vtbl=                 
{                                                           
 CEConnectionPoint_QueryInterface,                            
 CEConnectionPoint_AddRef,                                    
 CEConnectionPoint_Release,                                   
 CEConnectionPoint_GetConnectionInterface,                            
 CEConnectionPoint_GetConnectionPointContainer,
 CEConnectionPoint_Advise,
 CEConnectionPoint_Unadvise,
 CEConnectionPoint_EnumConnections
};

 

HRESULT __stdcall CEClassFactory_QueryInterface(IClassFactory* this, REFIID riid, void** ppv)
{
 if(IsEqualIID(riid,&IID_IUnknown) || IsEqualIID(riid,&IID_IClassFactory))
 {
    this->lpVtbl->AddRef(this); 
    *ppv=this;                  
    return(NOERROR);            
 }                               
 *ppv=0;                        
                                
 return(E_NOINTERFACE);         
}


ULONG __stdcall CEClassFactory_AddRef(IClassFactory* this)  
{                                                           
 InterlockedIncrement(&g_lObjs);                            
 return(1);
}


ULONG __stdcall CEClassFactory_Release(IClassFactory* this)
{
 return(InterlockedDecrement(&g_lObjs));
}


HRESULT __stdcall CEClassFactory_CreateInstance(IClassFactory* this, IUnknown* pUnkOuter, REFIID iid, void** ppv)
{
 CE* pCE=NULL;                                              
 HRESULT hr;                                              
	
 *ppv=0;                                                   
 if(pUnkOuter)                                              
    hr=CLASS_E_NOAGGREGATION;                              
 else                                                      
 {                                                         
    pCE=(CE*)CoTaskMemAlloc(sizeof(CE));
    if(pCE)                                                 
    {    
       pCE->lpIComCtrlVtbl=(IComCtrlVtbl*)&IComCtrl_Vtbl; 
       pCE->lpICPCVtbl=(IConnectionPointContainerVtbl*)&IConnectionPointContainer_Vtbl;
       pCE->lpICPVtbl=(IConnectionPointVtbl*)&IConnectionPoint_Vtbl;
       pCE->m_cRef=0; 
       pCE->hContainer=0;
       pCE->hControl=0;                               
       hr=pCE->lpIComCtrlVtbl->QueryInterface((IComCtrl*)pCE,iid,ppv); 
       if(SUCCEEDED(hr))                                    
          InterlockedIncrement(&g_lObjs);                  
       else                                                
          CoTaskMemFree(pCE);                              
    }                                                      
    else                                                   
       hr=E_OUTOFMEMORY;                                   
 } 
                                                           
 return(hr);                                               
} 


HRESULT __stdcall CEClassFactory_LockServer(IClassFactory* this, BOOL flock)
{
 if(flock)
    InterlockedIncrement(&g_lLocks);                        
 else                                                        
    InterlockedDecrement(&g_lLocks);                       
                                                           
 return(NOERROR);                                          
} 


const IClassFactoryVtbl IClassFactory_Vtbl=                 
{                                                           
 CEClassFactory_QueryInterface,                            
 CEClassFactory_AddRef,                                    
 CEClassFactory_Release,                                   
 CEClassFactory_CreateInstance,                            
 CEClassFactory_LockServer
};


HRESULT __stdcall DllGetClassObject(REFCLSID objGuid, REFIID facGuid, void** ppv)
{
 HRESULT hr;

 if(!memcmp(objGuid,&CLSID_CE,16))
    CEClassFactory_QueryInterface(&CEClassFactory, facGuid, ppv);
 else
 {
    *ppv=0;
    hr=CLASS_E_CLASSNOTAVAILABLE;
 }
 
 return(hr);
}


HRESULT __stdcall DllCanUnloadNow()
{
 if(g_lObjs||g_lLocks)
    return S_FALSE;
 else
    return S_OK;
}


STDAPI DllRegisterServer()
{
 ITypeLib* pTypeLib=NULL;
 HRESULT hr;
  
 hr=LoadTypeLibEx(L"CE.dll", REGKIND_DEFAULT, &pTypeLib);
 if(SUCCEEDED(hr))
 {
    pTypeLib->lpVtbl->Release(pTypeLib);
    hr=RegisterServer(g_hModule,&CLSID_CE,g_szFriendlyName,g_szVerIndProgID,g_szProgID);
    if(SUCCEEDED(hr))
       return hr;
    else
       return E_FAIL;
 }
 else
    return E_FAIL;
}                         


STDAPI DllUnregisterServer()
{
 HRESULT hr;

 hr=UnRegisterTypeLib(&LIBID_CE,1,0,LANG_NEUTRAL,SYS_WIN32);  
 if(SUCCEEDED(hr))
    return UnregisterServer(&CLSID_CE,g_szVerIndProgID,g_szProgID);
 else
    return E_FAIL;
}  


BOOL __stdcall DllMain(HINSTANCE hInstance, DWORD fdwReason, LPVOID lpvReserved)
{
 if(fdwReason==DLL_PROCESS_ATTACH)
 {
    g_hModule=hInstance;
    CEClassFactory.lpVtbl = (IClassFactoryVtbl*)&IClassFactory_Vtbl;
    DisableThreadLibraryCalls(hInstance);
 }

 return(TRUE);
}
*/






